---
title: Transport Layer Security
slug: Web/Security/Transport_Layer_Security
tags:
  - Authentication
  - Cryptography
  - Data Integrity
  - Encryption
  - Guide
  - SSL
  - Security
  - TLS
---
<p><span class="seoSummary">The security of any connection using Transport Layer Security (TLS) is heavily dependent upon the cipher suites and security parameters selected. This article's goal is to help you make these decisions to ensure the confidentiality and integrity communication between client and server.</span> The Mozilla Operations Security (OpSec) team <a href="https://wiki.mozilla.org/Security/Server_Side_TLS">maintains a wiki entry</a> with reference configurations for servers.</p>

<p class="summary">The Transport Layer Security (TLS) protocol is the standard for enabling two networked applications or devices to exchange information privately and robustly. Applications that use TLS can choose their security parameters, which can have a substantial impact on the security and reliability of data. This article provides an overview of TLS and the kinds of decisions you need to make when securing your content.</p>

<h2 id="History">History</h2>

<p>When HTTPS was introduced, it was based on Secure Sockets Layer (SSL) 2.0, a technology introduced by Netscape. It was updated to SSL 3.0 not long after, and as its usage expanded, it became clear that a common, standard encryption technology needed to be specified to ensure interoperability among all web browsers and servers. The <a href="https://www.ietf.org/">Internet Engineering Task Force</a> (IETF) specified TLS 1.0 in {{RFC(2246)}} in January, 1999. The current version of TLS is 1.3 ({{RFC(8446)}}).</p>

<div class="note">
<p>Despite the fact that the web now uses TLS for encryption, many people still refer to it as "SSL" out of habit.</p>
</div>

<p>Although TLS can be used on top of any low-level transport protocol, the original goal of the protocol was to encrypt HTTP traffic. HTTP encrypted using TLS is commonly referred to as {{Glossary("HTTPS")}}. TLS-encrypted web traffic is by convention exchanged on port 443 by default, while unencrypted HTTP uses port 80 by default. HTTPS remains an important use case for TLS.</p>

<h2 id="HTTP_over_TLS">HTTP over TLS</h2>

<p>TLS provides three primary services that help ensure the safety and security of data exchanged with it:</p>

<dl>
 <dt>Authentication</dt>
 <dd>Authentication lets each party to the communication verify that the other party is who they claim to be.</dd>
 <dt>Encryption</dt>
 <dd>Data is encrypted while being transmitted between the user agent and the server, in order to prevent it from being read and interpreted by unauthorized parties.</dd>
 <dt>Integrity</dt>
 <dd>TLS ensures that between encrypting, transmitting, and decrypting the data, no information is lost, damaged, tampered with, or falsified.</dd>
</dl>

<p>A TLS connection starts with a handshake phase where a client and server agree on a shared secret and important parameters, like cipher suites, are negotiated. Once parameters and a data exchange mode where application data, such HTTP, is exchanged.</p>

<h3 id="Cipher_suites">Cipher suites</h3>

<p>The primary parameters that the TLS handshake negotiates is a {{interwiki("wikipedia", "cipher suite")}}.</p>

<p>In TLS 1.2 and earlier, the negotiated cipher suite includes a set of cryptographic algorithms that together provide the negotiation of the shared secret, the means by which a server is authenticated, and the method that will be used to encrypt data.</p>

<p>The cipher suite in TLS 1.3 primarily governs the encryption of data, separate negotiation methods are used for key agreement and authentication.</p>

<p>Different software might use different names for the same cipher suites. For instance, the names used in OpenSSL and GnuTLS differ from those in the TLS standards. The <a href="https://wiki.mozilla.org/Security/Server_Side_TLS#Cipher_names_correspondence_table">cipher names correspondence table</a> on the Mozilla OpSec team's article on TLS configurations lists these names as well as information about compatibility and security levels.</p>

<h3 id="Configuring_your_server">Configuring your server</h3>

<p>Correctly configuring your server is crucial. In general, you should try to limit cipher support to the newest ciphers possible which are compatible with the browsers you want to be able to connect to your site. The <a href="https://wiki.mozilla.org/Security/Server_Side_TLS">Mozilla OpSec guide to TLS configurations</a> provides more information on recommended configurations.</p>

<p>To assist you in configuring your site, Mozilla provides a helpful <a href="https://mozilla.github.io/server-side-tls/ssl-config-generator/">TLS configuration generator</a> that will generate configuration files for the following Web servers:</p>

<ul>
 <li>Apache</li>
 <li>Nginx</li>
 <li>Lighttpd</li>
 <li>HAProxy</li>
 <li>Amazon Web Services CloudFormation Elastic Load Balancer</li>
</ul>

<p>Using the <a href="https://mozilla.github.io/server-side-tls/ssl-config-generator/">configurator</a> is a recommended way to create the configuration to meet your needs; then copy and paste it into the appropriate file on your server and restart the server to pick up the changes. The configuration file may need some adjustments to include custom settings, so be sure to review the generated configuration before using it; installing the configuration file without ensuring any references to domain names and the like are correct will result in a server that just doesn't work.</p>

<h2 id="TLS_1.3">TLS 1.3</h2>

<p>{{RFC("8446", "TLS 1.3")}} is a major revision to TLS. TLS 1.3 includes numerous changes that improve security and performance. The goals of TLS 1.3 are:</p>

<ul>
 <li>Remove unused and unsafe features of TLS 1.2.</li>
 <li>Include strong security analysis in the design.</li>
 <li>Improve privacy by encrypting more of the protocol.</li>
 <li>Reduce the time needed to complete a handshake.</li>
</ul>

<p>TLS 1.3 changes much of the protocol fundamentals, but preserves almost all of the basic capabilities as previous versions of TLS. For the web, TLS 1.3 can be enabled without affecting compatibility with some rare exceptions (see below).</p>

<p>The major changes in TLS 1.3 are:</p>

<ul>
 <li>The TLS 1.3 handshake completes in one round trip in most cases, reducing handshake latency.</li>
 <li>A server can enable a 0-RTT (zero round trip time) handshake. Clients that reconnect to the server can send requests immediately, eliminating the latency of the TLS handshake entirely. Though the performance gains from 0-RTT can be significant, they come with some risk of replay attack, so some care is needed before enabling this feature.</li>
 <li>TLS 1.3 supports forward-secure modes only, unless the connection is resumed or it uses a pre-shared key.</li>
 <li>TLS 1.3 defines a new set of cipher suites that are exclusive to TLS 1.3. These cipher suites all use modern Authenticated Encryption with Associated Data (AEAD) algorithms.</li>
 <li>The TLS 1.3 handshake is encrypted, except for the messages that are necessary to establish a shared secret. In particular, this means that server and client certificates are encrypted. Note however that the server identity (the server_name or SNI extension) that a client sends to the server is not encrypted.</li>
 <li>Numerous mechanisms have been disabled: renegotiation, generic data compression, {{interwiki("wikipedia", "Digital Signature Algorithm")}} (DSA) certificates, static RSA key exchange, and key exchange with custom Diffie-Hellman (DH) groups.</li>
</ul>

<p>Implementations of draft versions of TLS 1.3 are available. TLS 1.3 is enabled in some browsers, including the 0-RTT mode. Web servers that enable TLS 1.3 might need to adjust configuration to allow TLS 1.3 to operate successfully.</p>

<p>TLS 1.3 adds just one significant new use case. The 0-RTT handshake can provide significant performance gains for latency sensitive applications, like the web. Enabling 0-RTT requires additional steps, both to ensure successful deployment and to manage the risks of replay attacks.</p>

<p>The removal of renegotiation in TLS 1.3 might affect some web servers that rely on client authentication using certificates. Some web servers use renegotiation to either ensure that client certificates are encrypted, or to request client certificates only when certain resources are requested. For the privacy of client certificates, the encryption of the TLS 1.3 handshake ensures that client certificates are encrypted; however this might require some software changes. Reactive client authentication using certificates is supported by TLS 1.3 but not widely implemented. Alternative mechanisms are in the process of being developed, which will also support HTTP/2.</p>

<h2 id="Retiring_old_TLS_versions">Retiring old TLS versions</h2>

<p>To help with working towards a more modern, more secure web, TLS 1.0 and 1.1 support will be removed from all major browsers in Q1 2020.<strong> </strong>You'll need to make sure your web server supports TLS 1.2 or 1.3 going forward.</p>

<p>From version 74 onwards, Firefox will return a <a href="https://support.mozilla.org/en-US/kb/secure-connection-failed-firefox-did-not-connect">Secure Connection Failed</a> error when connecting to servers using the older TLS versions ({{bug(1606734)}}).</p>

<h2 id="TLS_handshake_timeout_values">TLS handshake timeout values</h2>

<p>If the TLS handshake starts to become slow or unresponsive for some reason, the user's experience can be affected significantly. To mitigate this problem, modern browsers have implemented handshake timeouts:</p>

<ul>
 <li>Since version 58, Firefox implements a TLS handshake timeout with a default value of 30 seconds. The timeout value can be varied by editing the <code>network.http.tls-handshake-timeout</code> pref in about:config.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>The <a href="https://ssl-config.mozilla.org">Mozilla SSL Configuration Generator</a> and <a href="https://cipherli.st/">Cipherli.st</a> can help you generate configuration files for your server to secure your site.</li>
 <li>The Mozilla Operations Security (OpSec) team maintains a wiki page with <a href="https://wiki.mozilla.org/Security/Server_Side_TLS">reference TLS configurations</a>.</li>
 <li><a href="https://observatory.mozilla.org/">Mozilla Observatory</a>, <a href="https://www.ssllabs.com/ssltest/">SSL Labs</a>, and <a href="https://github.com/mozilla/cipherscan">Cipherscan</a> can help you test a site to see how secure its TLS configuration is.</li>
 <li><a href="/en-US/docs/Web/Security/Secure_Contexts">Secure Contexts</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Headers/Strict-Transport-Security">Strict-Transport-Security</a> HTTP header</li>
</ul>

<p>{{QuickLinksWithSubpages("/en-US/docs/Web/Security")}}</p>
